function do_frm
parameters cForm, cTitle, cFile, cSetup, cDone
private nParms, lOK, lCleanup, nDest, nCancel, cDest, nLines, oLines
PRIVATE nArea, cRep, cTempRep,cTemp2
  nParms = Parameters()
  oLines = _PLength  && save current _plength setting
  nLines = oLines
  lCleanup = .F.
  DEFINE WINDOW repowin FROM 0,0 to 24,79 color scheme 1 ;
    TITLE "[ "+cTitle+ " - READ ONLY ]" NONE
  DEFINE WINDOW destwin FROM 4,20 to 16,60 color scheme 1 ;
  TITLE cTitle
  lOK = .T.
  IF nParms > 3
    lOK = Evaluate(cSetup)
    lCleanup = lOK
  ENDIF
  IF lOK
    ACTIVATE WINDOW destwin
    nDest = 1
    nCancel = 1
    @ 1,2 SAY "Destination: "  GET nDest ;
    PICTURE "@*RV \<Screen;\<Treeducer;\<Local;\<Network;\<File"
    @ 3,2 GET nCancel PICTURE "@*V \!\<OK;\?Cancel"
    READ CYCLE OBJECT 6
    IF nCancel == 1
      cTemp = Sys(3)
      cTempRep = cTemp + ".FRX"
      cTemp2   = cTemp + ".FRT"
      cTemp = cTemp + ".PRN"
      cDest = ""
      DO CASE
        CASE nDest == 1 && Screen
          cDest = "TO FILE "+cTemp
          nLines = 66
        CASE nDest == 2 && Treeducer
          SET LIBRARY TO ..\FOXTDC ADDITIVE
          SET UDFPARMS TO REFERENCE
          lOK = TreeSet( nLines )
          SET UDFPARMS TO VALUE
          cDest = "TO FILE "+cTemp
        CASE nDest == 3 && Local Printer
          cDest = "TO PRINT"
          SET PRINTER TO LPT1
          nLines = 60
        CASE nDest == 4 && Network Printer
          cDest = "TO PRINT"
          SET PRINTER TO LPT1
          nLines = 60
        CASE nDest == 5 && File
          cDest = "TO FILE "+cFile
          nLines = 66
      ENDCASE
      IF lOK

        _PLength = nLines
        cRep = cForm+".FRX"
        nArea = Select(0)
        SELE 0
        USE (cRep)
        COPY FOR !deleted() TO (cTempRep)
        USE (cTempRep)
        Locate for objtype = 1 .and. platform = "DOS"
        IF Found()
        REPLACE height WITH nLines
        ENDIF
        USE
        SELECT (nArea)

        Report FORM (cTempRep) NOEJECT NOCONSOLE &cDest  WHILE FrmStatus()
        ERASE &cTempRep
        ERASE &cTemp2
        _PLength = oLines && reset _plength to saved setting

        DO CASE
          CASE nDest == 1 && Screen
            modify file &cTemp NOEDIT WINDOW repowin
            *DO acdisp WITH cTemp
            erase &cTemp
          CASE nDest == 2 && Treeducer
            =Treeduce(cTemp)
            erase &cTemp
          CASE nDest == 3 && Local Printer
            EJECT
            SET PRINTER TO
            SET PRINT OFF
          CASE nDest == 4 && Network Printer
            EJECT
            SET PRINTER TO
            SET PRINT OFF
          CASE nDest == 5 && File
            SET PRINTER TO
            SET PRINT OFF
        ENDCASE
      ENDIF
      IF nDest = 2
        RELEASE LIBRARY ..\FOXTDC
      ENDIF
    ENDIF
  ENDIF
  IF lCleanup .and. nParms > 4
    = &cDone
  ENDIF
  RELEASE WINDOW destwin
  RELEASE WINDOW repowin
RETURN .T.

FUNCTION FrmStatus
  IF Woutput('destwin')
    @ 8,5 SAY "Page:"+Padl(_PAGENO,3)+"    Line:"+Padl(_PLINENO,3)
  ELSE
    ACTIVATE WINDOW destwin
    @ 8,5 SAY "Page:"+Padl(_PAGENO,3)+"    Line:"+Padl(_PLINENO,3)
    DEACTIVATE WINDOW destwin
  ENDIF
RETURN .T.
