
#define INVMACRO 253

#define LJ_CONDENSED         "(10U(s0p16.67h8v0s0b0T"
#define LJ_NORMAL            "(10U(s0p10h12v0s0b3T"
#define LJ_HELV14BOLD     "(0U(s1p14.0v0s3b4148T"
#define LJ_HELV12BOLD     "(0U(s1p12v0s3b4148T"
#define LJ_UNIVERSE12     "(0U(s1p12v0s0b4148T"
#define LJ_I10_LPRINTER   "(0N(s0p16.67h8.5v0s0b0T"

FUNCTION Invoice
  SET TALK OFF
  set printer to prn

  =Macro()
  ??? (LJ_Run(INVMACRO))
  ??? (LJ_Del(INVMACRO))

  ??? lj_gorc(9,63)
  ??? ("0034234")
  ??? lj_gorc(11,9)
  ??? ("SCT Associates, Inc.")
  ??? lj_gorc(12,9)
  ??? ("9221 S. Kilpatrick")
  ??? lj_gorc(13,9)
  ??? ("Oak Lawn, Il. 60453")
  ??? lj_gorc(12,62)
  ??? ("Aug 10, 1992")
  ??? lj_gorc(15,62)
  ??? ("SCT")
  ??? lj_gorc(15,73)
  ??? ("1")
  ??? lj_gorc(22,9)
  ??? ("3 copies of Treeducer")
  ??? lj_gorc(22,62)
  ??? ("$  79.00")
  ??? lj_gorc(50,62)
  ??? ("$ 237.00")

  ??? lj_gorc(57,58)
  ??? (BarCode("0034234"))
  ??? lj_gorc(57,63)
  ??? ("0034234")
  =Macro()

  ??? Chr(12) && formfeed

  set printer to
RETURN (.t.)

FUNCTION Macro
  *// record macro
  ??? (LJ_Rec(INVMACRO))

  *// *********   draw boxes   **********

  *// the address box
  ??? (LJ_Box(510,200,310,1300,5,10))

  *// big box
  ??? (LJ_Box(925,200,1655,2050,5))

  *// heading line
  ??? (LJ_Goto(1035,200))
  ??? (LJ_HLine(2050))
    *// heading shading
    ??? (LJ_Box(925,200,110,2050,0,5))


  *// line just above total
  ??? (LJ_Goto(2470,200))
  ??? (LJ_HLine(2050))
    *// total shading
    ??? (LJ_Box(2470,200,110,2050,0,5))

  *// small heading box
  ??? (LJ_Box(380,1800,470,450,5))
    *// lines
    ??? (LJ_Goto(420,1800))
    ??? (LJ_HLine(450,1))

    ??? (LJ_Goto(583,1800))
    ??? (LJ_HLine(450,1))

    ??? (LJ_Goto(737,1800))
    ??? (LJ_HLine(450,1))

    ??? (LJ_Goto(543,1800))
    ??? (LJ_HLine(450,5))

    ??? (LJ_Goto(697,1800))
    ??? (LJ_HLine(450,5))

    ??? (LJ_Goto(697,2100))
    ??? (LJ_VLine(153,5))

    ??? (LJ_CONDENSED)
    ??? (LJ_Goto(415,1820))
    ??? ("INVOICE NUMBER")

    ??? (LJ_Goto(578,1820))
    ??? ("INVOICE DATE")
    ??? (LJ_Goto(732,1820))
    ??? ("CUSTOMER CODE    PAGE")
    *// print shading
    ??? (LJ_Box(380,1800,40,450,0,5))
    ??? (LJ_Box(543,1800,40,450,0,5))
    ??? (LJ_Box(697,1800,40,450,0,5))

  *// ********  Fill in the Text *********

  *// select font universe 12
  ??? (LJ_UNIVERSE12)

  ??? (LJ_Goto(810, 220))
  ??? ("Attn: Accounts Payable")

  *// select font helv bold 14
  ??? (LJ_HELV14BOLD)
  ??? (LJ_Goto(100,1000))
  ??? ("I N V O I C E")

  *// select font HELV BOLD 12
  ??? (LJ_HELV12BOLD)
  ??? (LJ_Goto(1000,1050))
  ??? ("Description")
  ??? (LJ_Goto(2550,1400))
  ??? ("Total Charges:")

  *// select font I10 lprinter
  ??? (LJ_I10_LPRINTER)
  *// comments at bottom of invoices
  ??? (LJ_Goto(2730,560))
  ??? ("A delinquency charge of 1" + Chr(189) + "% per month will be assessed on past due invoices.")
  ??? (LJ_Goto(2780,960))
  ??? ("PAYMENT TERMS: Net 30 Days")

  *// change font back to normal
  ??? (LJ_NORMAL)

  *// Set back to top of page
  ??? (LJ_Goto(0,0))

  *// End Macro
  ??? (LJ_Rec())

RETURN (.t.)





